﻿using System.Collections.Generic;
using System.Text;
using Telerik.Windows.Documents.Model;

namespace MergeFieldWithCustomName
{
    public class CustomMergeField : MergeField
    {
        private const string CustomFieldName = "CustomField";

        static CustomMergeField()
        {
            CodeBasedFieldFactory.RegisterFieldType(CustomMergeField.CustomFieldName, () => { return new CustomMergeField(); });
        }

        public override string FieldTypeName
        {
            get
            {
                return CustomMergeField.CustomFieldName;
            }
        }

        public override Field CreateInstance()
        {
            return new CustomMergeField();
        }

        protected override DocumentFragment GetDisplayNameFragment()
        {
            return base.CreateFragmentFromText(string.Format(Field.DisplayNameFragmentFormat, this.GetFriendlyFieldName(this.PropertyPath)));
        }

        private string GetFriendlyFieldName(string fieldName)
        {
            int lettersInEnglishAlphabet = 26;
            List<char> separators = new List<char>(lettersInEnglishAlphabet);
            for (int i = 0; i < lettersInEnglishAlphabet; i++)
            {
                separators.Add((char)('A' + i));
            }

            StringBuilder newFieldName = new StringBuilder();
            int previousIndex = 0;

            for (int i = 1; i < fieldName.Length; i++)
            {
                if (separators.Contains(fieldName[i]))
                {
                    if (previousIndex > 0)
                    {
                        newFieldName.Append(" ");
                    }
                    newFieldName.Append(fieldName.Substring(previousIndex, i - previousIndex));
                    previousIndex = i;
                }
            }

            newFieldName.Append(" " + fieldName.Substring(previousIndex));

            return newFieldName.ToString();
        }
    }

}
