﻿using System;
using System.Windows;
using Telerik.Windows.Documents.Model;
using Telerik.Windows.Documents.RichTextBoxCommands;

namespace MergeFieldWithCustomName
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private ExamplesDataContext exampleDataContext;

        public MainWindow()
        {
            InitializeComponent();

            this.exampleDataContext = new ExamplesDataContext();
            this.DataContext = exampleDataContext;

            this.radRichTextBox.Document.MailMergeDataSource.ItemsSource = exampleDataContext.Employees;

            this.radRichTextBox.DocumentChanged += radRichTextBox_DocumentChanged;
            this.radRichTextBox.CommandExecuting += radRichTextBox_CommandExecuting;
        }

        void radRichTextBox_CommandExecuting(object sender, Telerik.Windows.Documents.RichTextBoxCommands.CommandExecutingEventArgs e)
        {
            if (e.Command is InsertFieldCommand)
            {
                MergeField field = (e.CommandParameter as MergeField);
                if (field != null)
                {
                    if (field.PropertyPath == "MyTestFieldPath")
                    {
                        e.Cancel = true;
                        this.radRichTextBox.InsertField(new CustomMergeField() { PropertyPath = "MyTestFieldPath" }, FieldDisplayMode.Result);
                    }
                }
            }
        }

        void radRichTextBox_DocumentChanged(object sender, EventArgs e)
        {
            this.radRichTextBox.Document.MailMergeDataSource.ItemsSource = exampleDataContext.Employees;
        }
    }
}
